using Avanzis.QueryFramework;
using NUnit.Framework;

namespace Avanzis.QueryBuilder.NUnit.MsSql2000
{
    public class MsSql2000WhereClauseTest : WhereClauseTest
    {
        private Dialects previousDialect = Dialects.MSSql2005Dialect;

        [TestFixtureSetUp]
        public virtual void Setup()
        {
            previousDialect = QueryFrameworkConfiguration.Dialect;
            QueryFrameworkConfiguration.Dialect = Dialects.MSSql2000Dialect;
            QueryBuilder.QueryProcessor.ResetProcessor();
        }


        [TestFixtureTearDown]
        public virtual void TearDown()
        {
            QueryFrameworkConfiguration.Dialect = previousDialect;
        }

        [Test]
        public override void ParametersInWhereClause()
        {
            WhereClause where = new WhereClause();
            where.Filters.Add("TabId", SqlOperator.Equals, "@TabId");
            Assert.AreEqual("WHERE (TabId = @TabId)", where.ToString());
        }
    }
}
