using NUnit.Framework;

namespace Avanzis.QueryBuilder.NUnit
{
	/// <summary>
	/// Tests genricos del selectbuilder
	/// </summary>
	[TestFixture] 
	public abstract class SelectBuilderTest
	{
	    public abstract void SimpleSelectAll();
        public abstract void SimpleSelectFields();
        public abstract void SimpleDistinct();
        public abstract void SelectFieldsWithFilter();
	    public abstract void SelectFieldsWithFilterAndOperator();
        public abstract void SimpleOrderBy();
        public abstract void SimpleGroupBy();
        public abstract void SimpleHaving();
		public abstract void SimpleJoin();	

        public abstract void MultipleJoins();

        public abstract void SingleJoinWithMultipleConditions();

        public abstract void ReuseFieldsInWhereAndGroupBy();		

        public abstract void SimpleLimit10();

        public abstract void SimpleOffset10();

        public abstract void SimpleLimit20Offset10();

        public abstract void SimpleLimit20Offset10WithOrderBy();

        [Test]
        public void SelectBuilderConstructor()
        {
            SelectBuilder sb = new SelectBuilder("Articles.ArticleId,Articles.Name", "Articles");
            Assert.AreEqual(2, sb.Select.Fields.Count);
            Assert.AreEqual("Articles", sb.From.TableName);
            SelectBuilder cloned = (SelectBuilder)sb.Clone();
            Assert.AreEqual(cloned.ToString(), sb.ToString());
        }
	}
}
