namespace Avanzis.QueryBuilder
{
    /// <summary>
    /// Expresin ms simple. Es una cadena de texto
    /// </summary>
    public class StringExpression : QueryExpression
    {
        private string expression;

        /// <summary>
        /// Initializes a new instance of the <see cref="StringExpression"/> class.
        /// </summary>
        /// <param name="expression">The expression.</param>
        public StringExpression(string expression)
        {
            this.expression = expression;
        }

        #region Miembros de ICloneable

        /// <summary>
        /// Creates a new object that is a copy of the current instance.
        /// </summary>
        /// <returns>
        /// A new object that is a copy of this instance.
        /// </returns>
        public override object Clone()
        {
            StringExpression cloned = new StringExpression(this.Expression);
            return cloned;
        }

        #endregion

        /// <summary>
        /// Gets or sets the expression.
        /// </summary>
        /// <value>The expression.</value>
        public string Expression
        {
            get { return expression; }
            set { expression = value; }
        }

        /// <summary>
        /// Gets the expression.
        /// </summary>
        /// <returns></returns>
        public override string GetExpression()
        {
            return expression;
        }
    }
}