using System;
using System.Configuration;
using System.Collections.Generic;
using System.Text;


namespace Avanzis.Helpers.QueryBuilder
{
    /// <summary>
    /// Configuracin del QueryBuilder
    /// </summary>
    public class QueryBuilderConfiguration
    {
        private QueryBuilderConfiguration() { }

        private static Dialects dialect = Dialects.MSSql2005Dialect;

        /// <summary>
        /// Gets or sets the dialect of the Database
        /// </summary>
        /// <value>The dialect.</value>
        public static Dialects Dialect
        {
            get
            {
                return dialect;
            }
            set
            {
                dialect = value;                
            }
        }

        /// <summary>
        /// Initializes the framework from web config.
        /// </summary>
        public static void InitializeFromWebConfig()
        {   
            if (!String.IsNullOrEmpty(ConfigurationManager.AppSettings["QueryBuilderDialect"]))
                QueryBuilderConfiguration.Dialect = (Dialects)Enum.Parse(typeof(Dialects), ConfigurationManager.AppSettings["QueryBuilderDialect"]);
        }
    
    }
}
