using System;
using NUnit.Framework;
using Avanzis.Helpers.QueryBuilder;

namespace Avanzis.Helpers.QueryBuilder.NUnit
{
	/// <summary>
	/// Descripcin breve de OrderClauseTest.
	/// </summary>
	[TestFixture]
	public class GroupByClauseTest
	{
		public GroupByClauseTest()
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//
		}
		
		[Test]
		public void EmptyGroupBy()
		{
			GroupByClause groupBy = new GroupByClause();
			Assert.AreEqual("", groupBy.ToString());
		}

		[Test]
		public void SimpleGroupBy()
		{
			GroupByClause groupBy = new GroupByClause("Articles.Name");
			Assert.AreEqual("GROUP BY Articles.Name", groupBy.ToString());

			groupBy = new GroupByClause();
			groupBy.Fields.Add("Articles.Name");
			Assert.AreEqual("GROUP BY Articles.Name", groupBy.ToString());
		}

		[Test]
		public void MultipleGroupBy()
		{
			GroupByClause groupBy = new GroupByClause("Articles.Name, Articles.Date");
			Assert.AreEqual("GROUP BY Articles.Name, Articles.Date", groupBy.ToString());
			
			groupBy = new GroupByClause();
			groupBy.Fields.Add("Articles.Name");
			groupBy.Fields.Add("Articles.Date");
			Assert.AreEqual("GROUP BY Articles.Name, Articles.Date", groupBy.ToString());
		}
	}
}
