using System;
using NUnit.Framework;
using Avanzis.Helpers.QueryBuilder;

namespace Avanzis.Helpers.QueryBuilder.NUnit
{
	/// <summary>
	/// Descripcin breve de HavingClauseTest.
	/// </summary>
	[TestFixture]
	public class HavingClauseTest
	{
		public HavingClauseTest()
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//
		}


		[Test]
		public void EmptyClause()
		{
			HavingClause having = new HavingClause();
			Assert.AreEqual("", having.ToString());

		}

		[Test]
		public void SimpleHaving()
		{
			HavingClause having = new HavingClause();
			having.Filters.Add("Articles.ArticleId = 29");
			Assert.AreEqual("HAVING (Articles.ArticleId = 29)", having.ToString());

			having = new HavingClause();
			having.Filters.Add("Articles.ArticleId", SqlOperator.Equals, 30);
			Assert.AreEqual("HAVING (Articles.ArticleId = 30)", having.ToString());
		}

		[Test]
		public void ComplexHaving()
		{
			HavingClause having = new HavingClause();
			having.Filters.Add("ArticleGroupSetType = 'O'");
			having.Filters.Add("ArticleGroupSets.Active = 1");			
			having.Union = FilterUnion.AND;
			Assert.AreEqual("HAVING (ArticleGroupSetType = 'O') AND (ArticleGroupSets.Active = 1)", having.ToString());

		}
		
	}
}
