using System;
using NUnit.Framework;
using Avanzis.Helpers.QueryBuilder;

namespace Avanzis.Helpers.QueryBuilder.NUnit
{
	/// <summary>
	/// Descripcin breve de WhereClauseTest.
	/// </summary>
	[TestFixture]
	public class WhereClauseTest
	{
		public WhereClauseTest()
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//
		}


		[Test]
		public void EmptyWhere()
		{
			WhereClause where = new WhereClause();
			Assert.AreEqual("", where.ToString());

		}

		[Test]
		public void SimpleWhere()
		{
			WhereClause where = new WhereClause();
			where.Filters.Add("Articles.ArticleId = 29");
			Assert.AreEqual("WHERE (Articles.ArticleId = 29)", where.ToString());

			where = new WhereClause();
			where.Filters.Add("Articles.ArticleId", SqlOperator.Equals, 30);
			Assert.AreEqual("WHERE (Articles.ArticleId = 30)", where.ToString());
		}

		[Test]
		public void ComplexWhere()
		{
			WhereClause where = new WhereClause();
			where.Filters.Add("ArticleGroupSetType = 'O'");
			where.Filters.Add("ArticleGroupSets.Active = 1");			
			where.Union = FilterUnion.AND;
			Assert.AreEqual("WHERE (ArticleGroupSetType = 'O') AND (ArticleGroupSets.Active = 1)", where.ToString());

		}

		
		
	}
}
