using System;

namespace Avanzis.QueryBuilder
{
    /// <summary>
    /// Clusula UPDATE
    /// </summary>
    public class UpdateClause : InsertClause
    {
        /// <summary>
        /// Constructor
        /// </summary>
        public UpdateClause()
        {
        }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="tableName">Nombre de la tabla</param>
        public UpdateClause(string tableName) : base(tableName)
        {
        }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="tableName">Nombre de la tabla</param>
        /// <param name="fieldValues">Coleccin de campos/valor</param>
        public UpdateClause(string tableName, SqlFieldValueCollection fieldValues) : base(tableName, fieldValues)
        {
        }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="fieldValues">Coleccin de campos/valor</param>
        public UpdateClause(SqlFieldValueCollection fieldValues) : base(fieldValues)
        {
        }


        /// <summary>
        /// EscapeValues = true;
        /// TODO: Faltaria implementar el caso para cuando no hay campos, solo valores.
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            if (TableName == null || TableName.Length == 0)
                throw new ArgumentNullException("TableName cannot be empty", "TableName");

            return QueryProcessor.Current.Process(this);
        }


        /// <summary>
        /// Devuelve un clon de esta consulta update
        /// </summary>
        /// <returns></returns>
        public override object Clone()
        {
            UpdateClause clone = new UpdateClause();

            clone.TableName = this.TableName;

            foreach (string field in this.FieldValues.Fields)
                clone.FieldValues.Add(field, this.FieldValues[field]);

            return clone;
        }
    }
}