using System.Collections.Generic;
using System.Data;
using System.Data.Common;

namespace Avanzis.QueryExecutor
{
    /// <summary>
    /// Coleccin de parmetros
    /// </summary>
    public class ParameterCollection : List<DbParameter>
    {
        public ParameterCollection()
        {

        }

        public ParameterCollection(IEnumerable<DbParameter> collection)
        {
            this.AddRange(collection);
        }

        public void Add(string parameterName, object value)
        {
            this.Add(Database.CreateParameter(parameterName, value));
        }

        public void Add(string parameterName, object value, DbType dataType)
        {
            DbParameter parameter = Database.CreateParameter(parameterName, value);
            parameter.DbType = dataType;
            this.Add(parameter);
        }

        #region Conversions

        public static implicit operator ParameterCollection(DbParameter[] parameters)
        {
            return new ParameterCollection(parameters);            
        }

        public static implicit operator DbParameter[](ParameterCollection parameterCollection)
        {
            return parameterCollection.ToArray();
        }        

        #endregion
    }
}
