using System.Data;
using System.Data.Common;
using Avanzis.QueryExecutor;
using Avanzis.QueryFramework;
using NUnit.Framework;

namespace Avanzis.QueryObjects.Tests
{    
    /// <summary>
    /// Test bsico del que heredarn el resto de Tests
    /// </summary>       
    public class BaseTest
    {
        public string connectionString = "server=localhost;database=queryobjects;uid=sa;pwd=mypasswordtest";
        
        [SetUp]
        public virtual void Setup()
        {            
            QueryObjectsConfiguration.ConnectionString = connectionString;
            QueryObjectsConfiguration.Dialect = Dialects.MSSql2005Dialect;
        }

        [TearDown]
        public virtual void TearDown()
        {
        }

        public object ExecuteScalar(string sql)
        {
            return Database.ExecuteScalar(connectionString, CommandType.Text, sql);
        }

        public DbDataReader ExecuteReader(string sql)
        {
            return Database.ExecuteReader(connectionString, CommandType.Text, sql);
        }

        public DataSet ExecuteDataset(string sql)
        {
            return Database.ExecuteDataset(connectionString, CommandType.Text, sql);
        }

        public void ExecuteNonQuery(string sql)
        {
            Database.ExecuteNonQuery(connectionString, CommandType.Text, sql);
        }
    }
}
