namespace Avanzis.QueryObjects.Tests
{
    [ActiveRecord("Stadiums")]
    public class Stadium : ActiveRecordBase<Stadium>
    {
        private string code;
        private string name;
        private StadiumType stadiumType;

        [PrimaryKey(Column = "Code", Generator = PrimaryKeyType.Assigned)]
        public string Code
        {
            get { return code; }
            set { code = value; }
        }

        [Property]
        public string Name
        {
            get { return name; }
            set { name = value; }
        }

        [Property(ColumnType="Int32")]
        public StadiumType StadiumType
        {
            get { return stadiumType; }
            set { stadiumType = value; }
        }
    }

    public enum StadiumType : int
    {
        NotSet = 0,
        Small = 1,
        Big = 2
    }


}
