using System;

namespace Avanzis.QueryObjects
{
    /// <summary>
    /// Atributo que marca aquellas clases que se persistirn en la BBDD
    /// </summary>
    [AttributeUsage(AttributeTargets.Class, AllowMultiple = false), Serializable]    
    public class ActiveRecordAttribute : System.Attribute
    {
        private String table;
        //private String discriminatorType;
        //private String discriminatorValue;
        //private String discriminatorColumn;
        // private String where;

        /// <summary>
        /// Initializes a new instance of the <see cref="T:PersistentClassAttribute"/> class.
        /// Usa el nombre de la clase como atributo
        /// </summary>
        public ActiveRecordAttribute()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="T:PersistentClassAttribute"/> class.
        /// </summary>
        /// <param name="tableName">Name of the table.</param>
        public ActiveRecordAttribute(string table)
        {
            this.table = table;
        }

        
        /// <summary>
        /// Nombre de la tabla
        /// </summary>
        public string Table
        {
            get { return table; }
            set { table = value; }
        }

        ///// <summary>
        ///// Gets or sets the Discriminator column for
        ///// a table inheritance modeling
        ///// </summary>
        //public String DiscriminatorColumn
        //{
        //    get { return discriminatorColumn; }
        //    set { discriminatorColumn = value; }
        //}

        ///// <summary>
        ///// Gets or sets the column type (like string or integer)
        ///// for the discriminator column
        ///// </summary>
        //public String DiscriminatorType
        //{
        //    get { return discriminatorType; }
        //    set { discriminatorType = value; }
        //}

        ///// <summary>
        ///// Gets or sets the value that represents the
        ///// target class on the discriminator column
        ///// </summary>
        //public String DiscriminatorValue
        //{
        //    get { return discriminatorValue; }
        //    set { discriminatorValue = value; }
        //}

        ///// <summary>
        ///// SQL condition to retrieve objects
        ///// </summary>
        //public String Where
        //{
        //    get { return where; }
        //    set { where = value; }
        //}
    }
}
